%  This Matlab file displays a 3-D picture of the figure that is to 
%  be analyzed in Assignment 3 in CS412 October, 2002.
%  Students should use it to see what the problem is about and
%  to see how to use the data files.


clear
clf

%  Get the coordinates of the joints.
%  The j-th line of the file gives the (x,y,z) coordinates for the j-th joint. 
%  xyz becomes an array with the data in Coordinates.dat.

xyz = load('Coordinates.dat') ;

%  Get the information about which joints the members connect.
%  The m-th line of the file Connections.dat gives the two joints that
%  member m connects.  For example, member 4 connects joints 2 and 5.
%  connect becomes an array with the data in Connections.dat.

connect = load('Connections.dat') ;

members = size(connect,1) ;  % How many members there are.

%  Draw the stick figure.  Line draws a line between two points.
%  I have it so each line connects the two points in a row of array connect.

for m = 1:members
    %  Get the two joints at the ends of the member.
    jnt1 = connect(m,1) ;
    jnt2 = connect(m,2) ;
    %  Get the coordinates of points (x1,y1,z1) and (x2,y2,z2)
    x1 = xyz(jnt1, 1 ) ;
    y1 = xyz(jnt1, 2 ) ;
    z1 = xyz(jnt1, 3 ) ;
    x2 = xyz(jnt2, 1 ) ;
    y2 = xyz(jnt2, 2 ) ;
    z2 = xyz(jnt2, 3 ) ;
    %  Change colors so it might be easier to figure out which line is which.
    %  Any how, it looks better this way.
    if mod( m,3 ) == 1
        color = 'blue' ;
    elseif mod( m,3 ) == 2
        color = 'magenta' ;
    else
        color = 'red' ;
    end
    %   Draw the line between the two points.
    line( [x1, x2], [y1,y2], [z1,z2], ...
      'Color',color,'Marker','o','MarkerFaceColor','black',...
                                 'MarkerEdgeColor','black') 
end

%   Hang a weight from the last joint.
jnt = size( xyz, 1) ;
x1 = xyz( jnt, 1 ) ;
y1 = xyz( jnt, 2 ) ;
z1 = xyz( jnt, 3 ) ;
x2 = x1 ;
y2 = y1 ;
z2 = z1 - 4 ;

line( [x1, x2], [y1,y2], [z1,z2], ...
           'Color','black','Marker','o','MarkerFaceColor','black',...
	                                'MarkerEdgeColor','black') 

%  Draw a 'line' at the last point to get a square there.  
%  There should be another way to do this, but
%  I don't have time to figure it out.  Also, the square is always 2-D.  
%  It would be nice to have it look 3D.
%  Does anyone have time to figure this out?

line( [x2, x2], [y2,y2], [z2,z2], ...
           'Color','black','Marker','sq','MarkerFaceColor','black',...
	      'MarkerEdgeColor','black', 'markerSize',15) 

%  Put a flat surface under the figure using z=0 and four corner points. 
surface( [-1 13 ; -1 13 ], [-7 -7 ; 7 7 ] , [0 0; 0 0] ,'FaceColor','green')
%  Put an axis down to help figure out the figure.
axis([ -1 13 -7 7 0 14 ] )

%  End of StaticsFigure.m
