function B = matrixB(n)

% function to construt a N X N matrix with each entry 
% each entry = 1/(sqrt(l)+sqrt(m)) where l is the row index
% and m is the column index of the element
% Input:    n = the number of row and column of the matrix
% Ouput:    B = the constructed matrix

% A and D help to do Row and Column Scaling
% L is the row scaling matrix
% M is the column scaleing matrix
A = ones(n,n);
D = diag([1:1:n]);
L = sqrt(D*A);
M = sqrt(A*D);
TEMP = L + M;

% do the element-wise division of the TEMP matrix
B = 1./TEMP;