function yi = lagrint(x,y,xi)
% lagrint - Interplation with Lagrange polynomials of arbitrary degree

dxi = xi - x;       % vector of xi - x(1), xi - x(2), ... values
n = length(x);      % degree of polynomial is n - 1
L = zeros(size(y)); % preallocate L for speed

L(1) = prod(dxi(2:n))/prod(x(1)-x(2:n));        % j = 1
L(n) = prod(dxi(1:n-1))/prod(x(n)-x(1:n-1));    % j = n
for j=2:n-1
    num = prod(dxi(1:j-1))*prod(dxi(j+1:n));
    den = prod(x(j)-x(1:j-1))*prod(x(j)-x(j+1:n));
    L(j) = num/den;
end
yi = sum(y.*L);     % Evaluate Polynomial : sum of y(j)*L(j), j = 1..nx