%   question 1a
%  get the coordinates of the points. (x,y,z)
%  xyz a matrix with the data in Connections.dat.
xyz = load('surface1.dat') ;

%  the # of row in A and Z
rowNum = size(xyz,1);

%  contruct A for quadratic fit
A = ones(rowNum, 6);
A(:,2)= xyz(:,1);
A(:,3)= xyz(:,2);
A(:,4)= xyz(:,1).^2;
A(:,5)= xyz(:,1).* xyz(:,2);
A(:,6)= xyz(:,2).^2;

%  construct z
Z = xyz(:,3);

%  solve for C in Ac ~= Z
C = A\Z
[Q0, R0] = qr(A,0);
w0 = Q0'*Z;
C_qr = R0\w0

%   Calculate the norm 2 of Ac-z and Q'z-Rc
[Q,R] = qr (A);

%   Right hand side elements
w = Q'*Z;

Ac_Norm = norm( (A*C) - Z )

%   neglected right hand side elements
RHS_Norm = norm( w( (size(A,2)+1) :rowNum) )

% plot the graph
clf;
plot3(xyz(:,1), xyz(:,2), xyz(:,3),'r+')
hold on
grid on
axis square

% contruct for the plot and mesh
X = [0:0.05:1];
X = X';
Y = [0:0.05:1];
Y = Y';
Z = zeros( length(Y), length(X) );

% contruct Z=f(x,y) for plot
% for each value of X in the evaluate Z for different Y
for j = 1:1:length(X)
%  contruct A for cubic fit
    A_plot = ones( length(X), 6);
    A_plot(:,2)= X(j);
    A_plot(:,3)= Y;
    A_plot(:,4)= X(j).^2;
    A_plot(:,5)= X(j).* Y;
    A_plot(:,6)= Y.^2;
    Z_plot = A_plot*C
    Z(:,j) = Z_plot;
end

mesh(X,Y,Z)
hold on