function I = newmethod(fun, a , b, n)

% newmethod  Composite New Method
% synopsis:  I= newmethod(fun, a, b, n)
% Input :    fun    = (string) name of m-file that evaluates f(x)
%            a, b   = lower and upper limits of the integral
%            n      = total number of nodes used in the integration

% Output :   I      = approximate value of the integral from a to b of f(x)*dx

h = (b-a)/n;            %stepsize
x1 = a + h/2;           %start of the interval
xn = b - h/2;           %stop of the interval
x = linspace(x1,xn,n);  %divide the interval
f = feval(fun,x);
%cs = spline(x,f);
%plot(x,ppval(cs,x),'-');

I = (h/8) * ( 9*sum(f(1:3:n-2)) + 6*sum(f(2:3:n-1)) + 9*sum(f(3:3:n)) );
%               f(1,4,7,..)         f(2,5,8..)          f(3,6,9,...)