function I = simpson(fun, a , b, npt)

% newmethod  Composite New Method
% synopsis:  I= newmethod(fun, a, b, n)
% Input :    fun    = (string) name of m-file that evaluates f(x)
%            a, b   = lower and upper limits of the integral
%            npt    = total number of pt -1 to use in the integration

% Output :   I      = approximate value of the integral from a to b of f(x)*dx

n = npt + 1;
h = (b-a)/(n-1);      %stepsize
x = a:h:b; %divide the interval (note : simpson need odd # of pts)
f = feval(fun,x);
%cs = spline(x,f);
%plot(x,ppval(cs,x),'-');

I = (h/3) * ( f(1) + 4*sum(f(2:2:n-1)) + 2*sum(f(3:2:n-2)) + f(n) );
%             f(a)         f(even)             f(odd)        f(b)