%   CS 412 Fall 2002
%   HW6 
%   Data Fok

%   Question 1
%   This file contains the matlab code to solve the
%   system of ODEs describing the compound pendulum.

%   Also need file CompoundPendulum.m

% Clear variables.
clear
clf 

% Global variables are needed to get information to the function pendulum.
global GG
global L0
global L1
global L2
global M1
global M2
global BB

param = [0.6 0.4 0.6 0.4; 0.7 0.3 0.2 0.8];

for k=1:2 

% Set the global variables.
L1 = param(k,1);
L2 = param(k,2);
M1 = param(k,3);
M2 = param(k,4);

fprintf('\nFor Case %d, L1 = %g, L2 = %g, M1 = %g, M2 = %g\n\n',k,L1,L2,M1,M2);
disp('Begin computation');
disp(' ');

% Set the initial and final time.
t0       =  0.0;
tfinal   = 10.0;

% Set the initial conditions. 
% given in the question
alpha0   = pi/2;
beta0    = pi/2;
alphadot0= 0;
betadot0 = 0;

% Put in standard form  z' = f( t, z ) 
z0 = [ alpha0, beta0, alphadot0, betadot0 ];

disp('Wait, this may take a while...' );

% Now solve it!  Use Matlab's automatic ODE solver, ode45.
% The function  CompoundPendulumODE  is in the file CompoundPendulumODE.m

options= odeset( 'RelTol', 1.e-7 ) ;
tspan = [t0, tfinal];
[t,z] = ode45('CompoundPendulumODE', tspan, z0, options );

% Plot the initial conditions and the solution in the (x,y) plane.

% Get the two variables.
alpha = z(:,1);
beta  = z(:,2);

% Compute the positions of M1 in the compound pendulum system.  (x0,y0) is the position for all the times.
x0 = L0.* sin( alpha ) + L1.* sin (pi-beta);
y0 = L0.* cos( alpha ) - L1.* cos (pi-beta);

% Compute the initial position.
% tmp = size(x0);

initp0x = L0*sin(alpha(1));
initp0y = L0*cos(alpha(1));

initpx = [ 0, initp0x ];
initpy = [ 0, initp0y ];

initm2x = initpx - L2*sin(pi-(beta(1)));
initm2y = initpy + L2*cos(pi-(beta(1)));

initm1x = x0(1);
initm1y = y0(1);

initmx = [initm1x, initm2x];
initmy = [initm1y, initm2y];

plot (initpx, initpy, 'ko', initpx, initpy, initmx, initmy,'bo',initmx, initmy, x0, y0);
% plot( initx, inity, 'o', initx, inity, x0, y0, 0., -hanglength, '+' );

% The axes are set to have all the plots be on the same axes.
% yhi = max( y0')*1.5 ;
% ylo = min( y0')*1.5 ;
% xlo = -(yhi - ylo)/2 ;
% xhi = -xlo ;
% axis( [  ylo, yhi, xlo, xhi ] );
axis( [ -3, 3, -3.5, 2.5 ] );

% Have the axes have the same length scales.
axis( 'square' );
if (k==1)
   title('Case 1');
else
   title('Case 2');
end

disp(' ');
disp('The plot shows the path of the pendulum mass (M1) in time.');
disp('Also shown is the initial position of the 2 mass of the pendulum.');

disp(' ');
disp('Hit any key to continue...');
pause;

end

