function compEM
% compEM        Compare Euler and Midpoint 
%
% Synopsis  :   compEM
%
% Output    :   Flops and global trunc errors for a sequence of stepsizes

tn = 3;     % length of interval
a0 = 0;     % IC

fprintf('\nh \ttimeE \terrE \ttimeM \terrM\n--------------------------------------------------------\n');
for h = [0.1 0.05 0.025 0.0125]
    tic; [te, ae] = odeEuler(inline('a + t + cos(t)','t','a'), tn, h, a0); timese = toc; % Euler
    tic; [tm, am] = odeMidpt(inline('a + t + cos(t)','t','a'), tn, h, a0); timesm = toc; % Midpoint
    
    % Global discretization errors
    aex = 0.5 * (3 * exp(te) + sin(te) - cos(te)) - 1 - te;  % Exact solution

    erre = max(abs(ae-aex));
    errm = max(abs(am-aex));

    %erre = norm(ae-aex,inf);
    %errm = norm(am-aex,inf);

    
    %erre = ae-aex;
    %errm = am-aex;

    fprintf('%.4f \t%.2f \t%.2f \t%.2f \t%.2f\n', h, timese, erre, timesm, errm);
end

       
