function midpt(h)
% input: h = stepsize
%
% output: a table comparing the numerical and exact solutions

tn = 3;         % stopping time
a0 = 0;         % IC

[t,a] = odeMidpt(inline('a + t + cos(t)','t','a'),tn,h,a0);    % Euler integration
aex = 0.5 * (3 * exp(t) + sin(t) - cos(t)) - 1 - t;  % Exact solution

for k = 1:length(t)
    t(k); a(k); aex(k); a(k)-aex(k);
end
fprintf('%.4f\t%10.2f\n',h, norm(a-aex,inf));